<?php
/*Plugin Name: Recent Stuff
Plugin URI: http://bueltge.de/
Description: Get recent post and comments, total posts, total comments and total categories
Version: 1.0
Author: Frank Bueltge
Author URI: http://bueltge.de/
*/

/* Instructions:
______________________________________________________________________________
follow functions for use it:

1. A counter for tatal posts: fb_total_posts();
2. A counter for total approved comments: fb_total_comments();
3. A counter for total categories: fb_total_categories();
4. Get recent posts (simple): fb_recent_post_simple();
	All varibablen is fill with content!
	You can use in the parametersdefinition:
	Example: fb_recent_posts_simple($limit = 10,
								$wordstart = 0,
								  $wordend = 200,
						   $postdateformat = 'd.m.Y, h:i',
							   $beforelink = '<h4>',
								$afterlink = '</h4>',
							$beforecontent = '<p>',
							 $aftercontent = ' ...<br />',
							   $beforedate = '<small>',
								$afterdate = '</small></p>',
								 $morelink = '<p class="more-link"><a href="%postlink%" title="%postauthor%\'s Kommentar lesen"><strong>Weiterlesen &raquo;</strong></a></p>'
								   );
  - limit = How many post to view?
  - wordstart = start shortens the content at this number of chars
  - wordend = shortens the content if it is longer than this number of chars
  - postdateformat = Format for the post-date, mor einformations in the date-function of php
  - beforelink = strings before content (xhtml)
  - aftercontent = srings after content (xhtml)
  - beforedate = strings before date (xhtml)
  - afterdate = strings after date (xhtml)
  - morelink = format for link to read
  ** - you can use: %postlink%, %postauthor%

 5. Get recent comments (simple): fb_recent_comments_simple();
	 All varibalen are filled. You can change in the function.
	 It give it possible parameters:
	 Example: fb_recent_comments_simple($limit = 10,
									$wordstart = 0,
									  $wordend = 50,
							$commentdateformat = 'd.m.Y, h:i',
								   $beforelink = '<h4>%commentauthor% zu ',
									$afterlink = '</h4>',
								$beforecontent = '<p>',
								 $aftercontent = ' ...<br />',
								   $beforedate = '<small>',
									$afterdate = '</small></p>',
									 $morelink = '<p class="more-link"><a href="%commentlink%" title="%commentauthor%\'s Kommentar lesen"><strong>Weiterlesen &raquo;</strong></a></p>'
									   );
  - limit = How many comments to view?
  - wordstart = start shortens the content of comment at this number of chars
  - wordend = shortens the content of comment if it is longer tha  this number of chars
  - postdateformat = Format for the post-date, mor einformations in the date-function of php
  - beforelink = strings before content (xhtml)
  - aftercontent = srings after content (xhtml)
  - beforedate = strings before date (xhtml)
  - afterdate = strings after date (xhtml)
  - morelink = format for link to read
  ** - you can use: %commentlink%, %commentauthor%

6. Get recent posts: fb_recent_posts( $limit = '0,10', 
								 $categories = '',  // space separated list of category IDs -- leave empty to get all
								 $dateformat = 'd.m.Y, h:i',
							$wordwrap_length = 50,  // adds a blank if word is longer than this number of chars
							   $title_length = 100, // shortens the title if it is longer than this number of chars
									 $format = '<h4><a href="%permalink%" title="%permalink%">%title%</a><small> %comment_count_full% %date%</small></h4>',
					   $format_comments_none = '(0)',
				   $format_comments_standard = '(%comment_count%)',
			$format_comments_none_and_closed = '',
								$content_ask = 1, //1 for Yes content, 0 for Not content
								  $wordstart = 0,
									$wordend = 200,
							  $beforecontent = '<p>',
							   $aftercontent = ' ...</p>',
								   $morelink = '<p class="more-link"><a href="%permalink%" title="%title% lesen"><strong>Weiterlesen &raquo;</strong></a></p>'
									);
  - limit = How many posts to view (start, end)?
  - categories = category IDs for filter or leave empty for all
  - dateformat = Format of the date, more informations at the date-function of php
  - wordwrap_length = adds a blank if word is longer at the number of chars
  - title_length = shortens the title if it  is longer than this number of chars
  - format = format for the title (xhtml)
  - format_comments_none = format, if it none comment on the post
  - format_comments_none_and_closed = format, if it none comment and closed comment
  - content_ask = Do you will view content? 1 for yes, 0 for no
  - wordstart = start shortens the content of comment at this number of chars
  - wordend = shortens the content of comment if it is longer tha  this number of chars
  - beforecontent = strings before content (xhmtl)
  - aftercontent = srings after content (xhtml)
  - morelink = format for link to read
  ** - you can use: %permalink%, %title%, %comment_count%, %comment_count_full%, %date%
*/

// Get Total Posts
function fb_total_posts() {
	global $wpdb;
	$totalposts = $wpdb->get_var("SELECT COUNT(ID)
								   FROM $wpdb->posts
								  WHERE post_status = 'publish'
								 ");
	if (0 < $totalposts) $totalposts = number_format($totalposts);
	echo $totalposts;
}

// Get Total Comments
function fb_total_comments() {
	global $wpdb;
	$totalcomments = $wpdb->get_var("SELECT COUNT(comment_ID)
									   FROM $wpdb->comments
									  WHERE comment_approved = '1'
									");
	if (0 < $totalcomments) $totalcomments = number_format($totalcomments);
	echo $totalcomments;
}

// Get Total Categories
function fb_total_categories() {
	global $wpdb;
	$totalcats = $wpdb->get_var("SELECT COUNT(cat_ID)
								   FROM $wpdb->categories
								");
	if (0 < $totalcats) $totalcats = number_format($totalcats);
	echo $totalcats;
}

// Get recent Posts
function fb_recent_posts_simple($limit = 10,
							$wordstart = 0,
							  $wordend = 200,
					   $postdateformat = 'd.m.Y, h:i',
						   $beforelink = '<h4>',
							$afterlink = '</h4>',
						$beforecontent = '<p>',
						 $aftercontent = ' ...<br />',
						   $beforedate = '<small>',
							$afterdate = '</small></p>',
							 $morelink = '<p class="more-link"><a href="%postlink%" title="%postauthor%\'s Kommentar lesen"><strong>Weiterlesen &raquo;</strong></a></p>'
								) {
	global $wpdb;
	$recentposts = $wpdb->get_results("SELECT $wpdb->posts.ID, post_title, post_name, post_date, post_content
										 FROM $wpdb->posts
									LEFT JOIN $wpdb->users
										   ON $wpdb->users.ID = $wpdb->posts.post_author
										WHERE post_date_gmt < '".gmdate("Y-m-d H:i:s")."'
										  AND post_status = 'publish'
										  AND post_password = ''
									 ORDER BY post_date DESC
										LIMIT $limit
									 ");
									 
	foreach ($recentposts as $post) {
			  $post_title = htmlspecialchars(stripslashes($post->post_title));
			   $post_date = mysql2date($postdateformat, $post->post_date);
			$post_content = substr(strip_tags($post->post_content), $wordstart, $wordend);
			 $post_author = $post->post_author;
			   $permalink = get_permalink();

			// Replace MoreLink
			$element_morelink = $morelink;
					$postlink = $permalink;
			$element_morelink = str_replace('%postlink%', $postlink, $element_morelink);
			$element_morelink = str_replace('%postauthor%', $post_author, $element_morelink);
			echo "$beforelink<a href=\"".get_permalink()."\" title=\"$post_title\">$post_title</a>$afterlink\n";
			echo "$beforecontent$post_content$aftercontent";
			echo "$beforedate$post_date$afterdate\n";
			echo "$element_morelink\n";
	}
}

// Get Recent Comments
function fb_recent_comments_simple($limit = 10,
							   $wordstart = 0,
								 $wordend = 20,
					   $commentdateformat = 'd.m.Y, h:i',
							  $beforelink = '<h4>%commentauthor% zu ',
							   $afterlink = '</h4>',
						   $beforecontent = '<p>',
							$aftercontent = '<br />',
							  $beforedate = '<small>',
							   $afterdate = '</small></p>',
								$morelink = '<p class="more-link"><a href="%commentlink%" title="%commentauthor%\'s Kommentar lesen"><strong>Weiterlesen &raquo;</strong></a></p>'
								   ) {
	global $wpdb, $post;
	$recentcomments = $wpdb->get_results("SELECT $wpdb->posts.ID, post_title, post_name, comment_ID, comment_author, post_date, comment_date, comment_content
											FROM $wpdb->posts
									  INNER JOIN $wpdb->comments
											  ON $wpdb->posts.ID = $wpdb->comments.comment_post_ID
										   WHERE comment_approved = '1'
											 AND post_date_gmt < '".gmdate("Y-m-d H:i:s")."'
											 AND post_status = 'publish'
											 AND post_password = ''
										ORDER BY comment_date DESC
										   LIMIT $limit
										  ");
										 
	foreach ($recentcomments as $post) {
			$post_title         = htmlspecialchars(stripslashes($post->post_title));
			$comment_id         = $post->comment_ID;
			$comment_author     = htmlspecialchars(stripslashes($post->comment_author));
			$comment_date       = mysql2date($commentdateformat, $post->comment_date);
			$text               = $post->comment_content;
			$text               = strip_tags($text);
			//$comment_content  = substr(strip_tags($post->comment_content), $wordstart, $wordend);
			$comment_content    = explode(' ', $text, $wordend + 1);
			if (count($comment_content) > $wordend) {
				array_pop($comment_content);
				$word             = array_pop($comment_content);
				$thelength        = strlen($word);
				$maxlenght_url    = '40';
				if ($thelength > $maxlength_url) {
					$word           = str_replace("http://www.","",$word);
					$word           = str_replace("http://","",$word);
					//$thelength      = strlen($word);
					$word           = $word . ' ...';
				}
				
				array_push($comment_content, ' ...');
				$text = implode(' ', $comment_content);
			}

			$permalink          = get_permalink();

			// Replace
			$comment_content    = $text;
			
			$commentlink        = $permalink.'#comment-'.$comment_id;
			
			$element_beforelink = $beforelink;
			$element_beforelink = str_replace('%commentlink%', $commentlink, $element_beforelink);
			$element_beforelink = str_replace('%commentauthor%', $comment_author, $element_beforelink);
			
			$element_morelink   = $morelink;
			$element_morelink   = str_replace('%commentlink%', $commentlink, $element_morelink);
			$element_morelink   = str_replace('%commentauthor%', $comment_author, $element_morelink);

			echo "$element_beforelink<a href=\"".get_permalink()."\" title=\"$post_title\">$post_title</a>$afterlink\n";
			if ($beforecontent != '') {
				echo "$beforecontent$comment_content$aftercontent";
			} else {
				echo "$beforecontent $aftercontent";
			}
			if ($commentdateformat != '') {
				echo "$beforedate$comment_date$afterdate\n";
			} else {
				echo "$beforedate $afterdate\n";	
			}
			echo "$element_morelink\n";
	}
}

// Recent Post
// Basisversion Recent Post with commentcounter by Michael Woehrer - sw-guide.de
function fb_recent_posts( $limit = '0,10', 
					 $categories = '',  // space separated list of category IDs -- leave empty to get all
					 $dateformat = 'd.m.Y, h:i', 
				$wordwrap_length = 50,  // adds a blank if word is longer than this number of chars
				   $title_length = 100, // shortens the title if it is longer than this number of chars
						 $format = '<h4><a href="%permalink%" title="%permalink%">%title%</a><small> %comment_count_full% %date%</small></h4>',
		   $format_comments_none = '',
	   $format_comments_standard = '(%comment_count%)',
$format_comments_none_and_closed = '',
					$content_ask = 1, //1 for Yes content, 0 for Not content
					  $wordstart = 0,
						$wordend = 200,
				  $beforecontent = '<p>',
				   $aftercontent = ' ...</p>',
					   $morelink = '<p class="more-link"><a href="%permalink%" title="%title% lesen"><strong>Weiterlesen &raquo;</strong></a></p>'
						) {

	global $wpdb, $tablecomments, $tableposts, $tablepost2cat;

	// Check globals
	if (!isset($tableposts)) $tableposts = $wpdb->posts;
	if (!isset($tablecomments)) $tablecomments = $wpdb->comments;

	// Query
	$query = "	SELECT ID, post_date, post_title, comment_status, post_content
				FROM " . $tableposts;
	if ($categories != '') $query.= " LEFT JOIN $tablepost2cat ON ($tableposts.ID = $tablepost2cat.post_id)";				
	$query.= " WHERE (post_status = 'publish')
				AND (post_password = '')";
	if ($categories != '') {
		$catsArray = explode(' ', $categories);
		$first = 1;
		$query.= "AND ( ";
		foreach ($catsArray as $catLoop) {
			if ($first) $first = 0;
			else $sql.= "OR ";
			$query.= "$tablepost2cat.category_id = '$catLoop' ";
		}
		$query.= ") ";
	}
	$query.= " ORDER BY post_date DESC
				LIMIT $limit"; 

/*
	$query = "	SELECT ID, post_date, post_title, comment_status
				FROM " . $tableposts . "
				WHERE (post_status = 'publish')
				AND (post_password = '')
				ORDER BY post_date DESC
				LIMIT $limit";
*/


	$queryresult = $wpdb->get_results($query);

	if ($queryresult) {

		$result = '';
		foreach ($queryresult as $query_loop) {

			// Get post date
			$loop_res['date']      = mysql2date($dateformat, $query_loop->post_date);

			// Get permalink
			$loop_res['permalink'] = get_permalink($query_loop->ID);

			// Get post title
			$loop_res['title']     = stripslashes($query_loop->post_title);
			$loop_res['title']     = wordwrap($loop_res['title'], $wordwrap_length, ' ' , 1);
			if (strlen($loop_res['title']) >= $title_length) { 
				$loop_res['title'] = substr($loop_res['title'], 0, $title_length) . '&#8230;';
			}
			
			// Get Post content
			if ($content_ask == 1) {
				$loop_res['content']   = substr(strip_tags($query_loop->post_content), $wordstart, $wordend);
				$result_content = $beforecontent.$loop_res['content'].$aftercontent . "\n";
			} else {
				$result_content = '';
			}
			
			// Get data from database
			$query2 = "SELECT COUNT(*) 
							   FROM $tablecomments 
							  WHERE comment_post_ID = " . $query_loop->ID;
			$result_commentscount = $wpdb->get_var($query2);

			// Prepare format of output
			if ( $result_commentscount > 0 ) {
				$tmp_format = $format_comments_standard;
			} elseif ( $result_commentscount == 0 ) {
				if ( $query_loop->comment_status == 'open' ) {
					$tmp_format = $format_comments_none;
				} else {
					$tmp_format = $format_comments_none_and_closed;
				}
			} 

			// Result			
			$loop_res['comment_count_full'] = str_replace('%comment_count%', $result_commentscount, $tmp_format);
			
			// Generate output
			$element_loop = $format;
			$element_loop = str_replace('%date%', $loop_res['date'], $element_loop);
			$element_loop = str_replace('%permalink%', $loop_res['permalink'], $element_loop);
			$element_loop = str_replace('%title%', $loop_res['title'], $element_loop);
			$element_loop = str_replace('%comment_count_full%', $loop_res['comment_count_full'], $element_loop);

			//Get morelink
			$element_morelink = $morelink;
			$element_morelink = str_replace('%permalink%', $loop_res['permalink'], $element_morelink);
			$element_morelink = str_replace('%title%', $loop_res['title'], $element_morelink);
			
			$result.= $element_loop . "\n";
			$result.= $result_content . "\n";
			$result.= $element_morelink . "\n";
		} // End  foreach

		echo $result;
	}
}

define('FB_Total_Posts', '<!--total_posts-->');
define('FB_Total_Comments', '<!--total_comments-->');
define('FB_Total_Categories', '<!--total_categories-->');

function fb_total_posts_filter($data) {
	$start = strpos($data, FB_Total_Posts);
	if($start !== false) {
		ob_start();
		fb_total_posts();
		$content = ob_get_contents();
		ob_end_clean();
		$data = substr_replace($data, $content, $start, strlen(FB_Total_Posts));
	}
	return $data;
}

function fb_total_comments_filter($data) {
	$start = strpos($data, FB_Total_Comments);
	if($start !== false) {
		ob_start();
		fb_total_comments();
		$content = ob_get_contents();
		ob_end_clean();
		$data = substr_replace($data, $content, $start, strlen(FB_Total_Comments));
	}
	return $data;
}

function fb_total_categories_filter($data) {
	$start = strpos($data, FB_Total_Categories);
	if($start !== false) {
		ob_start();
		fb_total_categories();
		$content = ob_get_contents();
		ob_end_clean();
		$data = substr_replace($data, $content, $start, strlen(FB_Total_Categories));
	}
	return $data;
}


if(function_exists('add_filter')) {
	add_filter('the_content', 'fb_total_posts_filter');
	add_filter('the_content', 'fb_total_comments_filter');
	add_filter('the_content', 'fb_total_categories_filter');
}
?>